//     bluetooth
// 3.
// :
// -  "ERASE=X" -    
// - "ERASE=0"   
// - "SPEED=X"   
// -    .
//    .
//     "#",    ,   
//  "#".
//  
//   ^
volatile unsigned short video_mem[8][10];
volatile unsigned short k, flags, l, Nzn, rab, rab_p, kol=0,
                        adress=0x00, code_sym, kol_pust=0,
                        code_part1[63], //code_part2[63],
                        speed, zer1, zer2, s=0, k_eeprom=3, text_comand[7];


volatile unsigned short wait_tab=0;
const bold=7; //       
              //(     )
const merz=7; //  =1,    .
const zz=9;
const t_wait=180; //   /60 = 1 /.
                // "Tab"   10- ,   .


void interrupt () {
           flags.F0=1; //0 -    UART - .
           PIE1.F5=0;  //    USART.
                  }


void Init() {
            INTCON=0;
            CMCON=0x07;         // , PORTA  /
            TRISA=0b00001000;
            TRISB=0b11000011;
            PORTA=0;
            PORTB=0;
            OPTION_REG.F6=1;    //      ( 1  0)
            OPTION_REG.F7=0;    //  
            Usart_Init(9600);
//-*************************************************
            //speed = Eeprom_Read(0x7F); // .
            //if (speed==0) speed=1;
//-*************************************************
            }
void Symbol() {  //      
               switch (code_sym) {
                   case 0x0D: goto s_20; // 
                   case 0x20: goto s_20; //
                   case 0x21: goto s_21; //!
                   case 0x24: goto s_24; //$
                   case 0x25: goto s_25; //%
                   case 0x26: goto s_26; //&
                   case 0x27: goto s_27; //
                   case 0x28: goto s_28; //  
                   case 0x29: goto s_29; //  
                   case 0x2A: goto s_2A; // *
                   case 0x2B: goto s_2B; // +
                   case 0x2C: goto s_2C; // ,
                   case 0x2D: goto s_2D; // -
                   case 0x2E: goto s_2E; // .
                   case 0x2F: goto s_2F; // /
                   case 0x30: goto s_30; // 0
                   case 0x31: goto s_31; // 1
                   case 0x32: goto s_32; // 2
                   case 0x33: goto s_33; // 3
                   case 0x34: goto s_34; // 4
                   case 0x35: goto s_35; // 5
                   case 0x36: goto s_36; // 6
                   case 0x37: goto s_37; // 7
                   case 0x38: goto s_38; // 8
                   case 0x39: goto s_39; // 9
                   case 0x3A: goto s_3A; // :
                   case 0x3B: goto s_3B; // ;
                   case 0x3C: goto s_3C; // <
                   case 0x3D: goto s_3D; // =
                   case 0x3E: goto s_3E; // >
                   case 0x3F: goto s_3F; // ?
                   case 0x90: goto s_C0; // 
                   case 0x91: goto s_C1; // 
                   case 0x92: goto s_C2; // 
                   case 0x93: goto s_C3; // 
                   case 0x94: goto s_C4; // 
                   case 0x95: goto s_C5; // 
                   case 0x96: goto s_C6; // 
                   case 0x97: goto s_C7; // 
                   case 0x98: goto s_C8; // 
                   case 0x99: goto s_C9; // 
                   case 0x9A: goto s_CA; // 
                   case 0x9B: goto s_CB; // 
                   case 0x9C: goto s_CC; // 
                   case 0x9D: goto s_CD; // 
                   case 0x9E: goto s_CE; // 
                   case 0x9F: goto s_CF; // 
                   case 0xA0: goto s_D0; // 
                   case 0xA1: goto s_D1; // 
                   case 0xA2: goto s_D2; // 
                   case 0xA3: goto s_D3; // 
                   case 0xA4: goto s_D4; // 
                   case 0xA5: goto s_D5; // 
                   case 0xA6: goto s_D6; // 
                   case 0xA7: goto s_D7; // 
                   case 0xA8: goto s_D8; // 
                   case 0xA9: goto s_D9; // 
                   case 0xAA: goto s_DA; // 
                   case 0xAB: goto s_DB; // 
                   case 0xAC: goto s_DC; // 
                   case 0xAD: goto s_DD; // 
                   case 0xAE: goto s_DE; // 
                   case 0xAF: goto s_DF; // 
                   
                   case 0x40: goto s_20; // 
                   case 0x41: goto s_C0; // A
                   case 0x42: goto s_C2; // B
                   case 0x43: goto s_D1; // C
                   case 0x44: goto latD; // D
                   case 0x45: goto s_C5; // 
                   case 0x46: goto latF; // F
                   case 0x47: goto latG; // G
                   case 0x48: goto s_CD; // H
                   case 0x49: goto latI; // I
                   case 0x4A: goto latJ; // J
                   case 0x4B: goto s_CA; // K
                   case 0x4C: goto latL; // L
                   case 0x4D: goto s_CC; // M
                   case 0x4E: goto latN; // N
                   case 0x4F: goto s_CE; // O
                   case 0x50: goto s_D0; // 
                   case 0x51: goto latQ; // Q
                   case 0x52: goto latR; // R
                   case 0x53: goto latS; // S
                   case 0x54: goto s_D2; // T
                   case 0x55: goto latU; // U
                   case 0x56: goto latV; // V
                   case 0x57: goto latW; // W
                   case 0x58: goto s_D5; // X
                   case 0x59: goto s_D3; // Y
                   case 0x5A: goto latZ; // Z
                   case 0x5B: goto slv; //   
                   case 0x5C: goto sles; // \
                   case 0x5D: goto slp; //   
                   case 0x5E: goto apos; // 
                   case 0x5F: goto lat_; // _
                              }
s_2E:
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00110000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_20:          // 
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_21:          // !
               video_mem[0][zz] = 0b00110000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b00110000;
               video_mem[3][zz] = 0b00110000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_24:          //$
               video_mem[0][zz] = 0b00010000;
               video_mem[1][zz] = 0b00111100;
               video_mem[2][zz] = 0b01110000;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b00101100;
               video_mem[5][zz] = 0b00101100;
               video_mem[6][zz] = 0b11111000;
               video_mem[7][zz] = 0b01000000;
               goto dalshe;
s_25:          // %
               video_mem[0][zz] = 0b00100100;
               video_mem[1][zz] = 0b01010100;
               video_mem[2][zz] = 0b00101000;
               video_mem[3][zz] = 0b00010000;
               video_mem[4][zz] = 0b00101000;
               video_mem[5][zz] = 0b01010100;
               video_mem[6][zz] = 0b01001000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_26:          //&
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00100000;
               video_mem[2][zz] = 0b01010000;
               video_mem[3][zz] = 0b00100000;
               video_mem[4][zz] = 0b01010000;
               video_mem[5][zz] = 0b01001000;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_27:          //
               video_mem[0][zz] = 0b01000100;
               video_mem[1][zz] = 0b01000100;
               video_mem[2][zz] = 0b01100100;
               video_mem[3][zz] = 0b01010100;
               video_mem[4][zz] = 0b01001100;
               video_mem[5][zz] = 0b01000100;
               video_mem[6][zz] = 0b01000100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_28:          //  
               video_mem[0][zz] = 0b00110000;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_29:          // 
               video_mem[0][zz] = 0b00011000;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00001100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b00011000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_2A:          //*
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b01000100;
               video_mem[2][zz] = 0b00101000;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b00101000;
               video_mem[5][zz] = 0b01000100;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_2B:          // +
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00010000;
               video_mem[2][zz] = 0b00010000;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b00010000;
               video_mem[5][zz] = 0b00010000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_2C:
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00110000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b01100000;
               goto dalshe;
s_2D:
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;

s_2F:
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;

s_30:          //0
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;

s_31:          //1
               video_mem[0][zz] = 0b00011000;
               video_mem[1][zz] = 0b00111000;
               video_mem[2][zz] = 0b01011000;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00011000;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_32:          //2
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_33:          //3
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_34:          //4
               video_mem[0][zz] = 0b00001100;
               video_mem[1][zz] = 0b00011100;
               video_mem[2][zz] = 0b00101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01111110;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b00001100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_35:          //5
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01111000;
               video_mem[3][zz] = 0b00001100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_36:          //6
               video_mem[0][zz] = 0b00011000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_37:          //7
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00110000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01100000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_38:          //8
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_39:          //9
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_3A:          // :
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b00110000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b00110000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_3B:          // ;
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b00110000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b00110000;
               video_mem[6][zz] = 0b01000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_3C:          // <
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00011000;
               video_mem[2][zz] = 0b00110000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;

s_3D:          //=
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b01111100;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b01111100;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_3E:          // >
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00001100;
               video_mem[4][zz] = 0b00011000;
               video_mem[5][zz] = 0b00110000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_3F:          // ?
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C0:          //
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C1:          //
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01111000;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C2:          //
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C3:          //   
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01100000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C4:          //
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b11111110;
               video_mem[7][zz] = 0b11000110;
               goto dalshe;
s_C5:          //
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C6:          //
               video_mem[0][zz] = 0b01011010;
               video_mem[1][zz] = 0b01011010;
               video_mem[2][zz] = 0b00111100;
               video_mem[3][zz] = 0b01011010;
               video_mem[4][zz] = 0b01011010;
               video_mem[5][zz] = 0b01011010;
               video_mem[6][zz] = 0b01011010;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C7:          //
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C8:          //
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_C9:          //
               video_mem[0][zz] = 0b01010100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CA:           //
               video_mem[0][zz] = 0b01101000;
               video_mem[1][zz] = 0b01101000;
               video_mem[2][zz] = 0b01101000;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CB:          //
               video_mem[0][zz] = 0b00011100;
               video_mem[1][zz] = 0b00101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CC:          //
               video_mem[0][zz] = 0b01000010;
               video_mem[1][zz] = 0b01100110;
               video_mem[2][zz] = 0b01111110;
               video_mem[3][zz] = 0b01100110;
               video_mem[4][zz] = 0b01100110;
               video_mem[5][zz] = 0b01100110;
               video_mem[6][zz] = 0b01100110;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CD:          //
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CE:          //   O
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_CF:          //   
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D0:          //   
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01100000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D1:          //   C
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D2:          //   T
               video_mem[0][zz] = 0b01111110;
               video_mem[1][zz] = 0b00011000;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00011000;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00011000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D3:          //   
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b01110000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D4:          //   
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b01011010;
               video_mem[2][zz] = 0b01011010;
               video_mem[3][zz] = 0b01011010;
               video_mem[4][zz] = 0b00111100;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00011000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D5:          //   X
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01101100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D6:          //   
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111110;
               video_mem[7][zz] = 0b00000110;
               goto dalshe;
s_D7:          //   
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b00001100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D8:          //   
               video_mem[0][zz] = 0b01000100;
               video_mem[1][zz] = 0b01000100;
               video_mem[2][zz] = 0b01010100;
               video_mem[3][zz] = 0b01010100;
               video_mem[4][zz] = 0b01010100;
               video_mem[5][zz] = 0b01010100;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_D9:          //   
               video_mem[0][zz] = 0b01000100;
               video_mem[1][zz] = 0b01000100;
               video_mem[2][zz] = 0b01010100;
               video_mem[3][zz] = 0b01010100;
               video_mem[4][zz] = 0b01010100;
               video_mem[5][zz] = 0b01010100;
               video_mem[6][zz] = 0b01111110;
               video_mem[7][zz] = 0b00000010;
               goto dalshe;
s_DA:          //   
               video_mem[0][zz] = 0b01110000;
               video_mem[1][zz] = 0b00110000;
               video_mem[2][zz] = 0b00110000;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00110110;
               video_mem[5][zz] = 0b00110110;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_DB:          //   
               video_mem[0][zz] = 0b01100110;
               video_mem[1][zz] = 0b01100110;
               video_mem[2][zz] = 0b01100110;
               video_mem[3][zz] = 0b01110110;
               video_mem[4][zz] = 0b01101110;
               video_mem[5][zz] = 0b01101110;
               video_mem[6][zz] = 0b01110110;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_DC:          //   
               video_mem[0][zz] = 0b01100000;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_DD:          //   
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_DE:          //   
               video_mem[0][zz] = 0b01001100;
               video_mem[1][zz] = 0b01011010;
               video_mem[2][zz] = 0b01011010;
               video_mem[3][zz] = 0b01111010;
               video_mem[4][zz] = 0b01011010;
               video_mem[5][zz] = 0b01011010;
               video_mem[6][zz] = 0b01001100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
s_DF:          //   
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b00111100;
               video_mem[4][zz] = 0b00111100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01001100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latD:          //   D
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latF:          //F
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01100000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latG:          //   G
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01111100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latI:          //   I
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b00011000;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00011000;
               video_mem[4][zz] = 0b00011000;
               video_mem[5][zz] = 0b00011000;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latJ:          //J
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00001100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latL:          //   L
               video_mem[0][zz] = 0b01100000;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latN:          //N
               video_mem[0][zz] = 0b01100110;
               video_mem[1][zz] = 0b01100110;
               video_mem[2][zz] = 0b01110110;
               video_mem[3][zz] = 0b01101110;
               video_mem[4][zz] = 0b01100110;
               video_mem[5][zz] = 0b01100110;
               video_mem[6][zz] = 0b01100110;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latQ:          //Q
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01111100;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latR:          //   R
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01111000;
               video_mem[4][zz] = 0b01111000;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b01100100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latS:          //   S
               video_mem[0][zz] = 0b00111000;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b00111000;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latU:          //U
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b01101100;
               video_mem[6][zz] = 0b00111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latV:          //V
               video_mem[0][zz] = 0b01101100;
               video_mem[1][zz] = 0b01101100;
               video_mem[2][zz] = 0b01101100;
               video_mem[3][zz] = 0b01101100;
               video_mem[4][zz] = 0b01101100;
               video_mem[5][zz] = 0b00101000;
               video_mem[6][zz] = 0b00010000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latW:          //   W
               video_mem[0][zz] = 0b01000100;
               video_mem[1][zz] = 0b01000100;
               video_mem[2][zz] = 0b01010100;
               video_mem[3][zz] = 0b01010100;
               video_mem[4][zz] = 0b01010100;
               video_mem[5][zz] = 0b01010100;
               video_mem[6][zz] = 0b00101000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
latZ:          //Z
               video_mem[0][zz] = 0b01111100;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00011000;
               video_mem[3][zz] = 0b00010000;
               video_mem[4][zz] = 0b00110000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
slv:          //   
               video_mem[0][zz] = 0b01111000;
               video_mem[1][zz] = 0b01100000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b01100000;
               video_mem[4][zz] = 0b01100000;
               video_mem[5][zz] = 0b01100000;
               video_mem[6][zz] = 0b01111000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
slp:          //   
               video_mem[0][zz] = 0b00111100;
               video_mem[1][zz] = 0b00001100;
               video_mem[2][zz] = 0b00001100;
               video_mem[3][zz] = 0b00001100;
               video_mem[4][zz] = 0b00001100;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b00111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
sles:          // \
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b01000000;
               video_mem[2][zz] = 0b01100000;
               video_mem[3][zz] = 0b00110000;
               video_mem[4][zz] = 0b00011000;
               video_mem[5][zz] = 0b00001100;
               video_mem[6][zz] = 0b00000100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
apos:          // "
               video_mem[0][zz] = 0b00010100;
               video_mem[1][zz] = 0b00101000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;
lat_:          // _
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b01111100;
               video_mem[7][zz] = 0b00000000;
               goto dalshe;

dalshe:       asm {nop}
              l=0;
              while (l<8) {
              zer1 = video_mem[l][zz]; zer2 = zer1;
              if (zer1.F7==0) zer1.F0=0; else zer1.F0=1;
              if (zer1.F6==0) zer1.F1=0; else zer1.F1=1;
              if (zer1.F5==0) zer1.F2=0; else zer1.F2=1;
              if (zer1.F4==0) zer1.F3=0; else zer1.F3=1;
              if (zer2.F0==0) zer1.F7=0; else zer1.F7=1;
              if (zer2.F1==0) zer1.F6=0; else zer1.F6=1;
              if (zer2.F2==0) zer1.F5=0; else zer1.F5=1;
              if (zer2.F3==0) zer1.F4=0; else zer1.F4=1;
              video_mem[l][zz] = zer1;
              l++;
                          }
              }
void Clear_screen() {
                        //  
           l=0;                              // 
           while (l<10) {
           k=0;                              //   
           while (k<8) {video_mem[k][l] =0;
               k++;}
               l++;
                        }
                    }
int Scroll(unsigned short a) {
              //  
              while (a>0) {
             l=0;
             while (l<8)  {Nzn=0;
              while (Nzn<zz) {
                  rab = video_mem[l][Nzn]; rab_p = video_mem[l][Nzn+1];
                  asm {RRF _rab_p
                       RRF _rab}
                  video_mem[l][Nzn] = rab;
                  if (Nzn==zz-1) video_mem[l][Nzn+1] = rab_p;
                  Nzn++;                       }
              PORTA = l; PORTB.F4 = 1; PORTB.F4 = 0;
              l++;       }
              a--;           }
              }

int Output(unsigned short zaderzka) { // zaderzka  
              //   
           while (zaderzka>0) {
           l=0;
           while (l<8)  {Nzn=zz;
              while (Nzn!=0xFF) {
                  rab = video_mem[l][Nzn];
                  k=0;
              while (k<8) {
                  asm {RRF _rab}
                  if (STATUS.F0==1) PORTB.F5=1; else PORTB.F5=0;
                  PORTB.F3 = 1; PORTB.F3 = 0;
                  k++;                 }
                  Nzn--;                       }
              PORTA = l; PORTB.F4 = 1; Delay_us(merz); PORTB.F4 = 0;
              l++;       }
              zaderzka--;
                          }
              Nzn=zz;
              while (Nzn!=0xFF) {
                  k=0;
              while (k<8) {
                  PORTB.F5=0;
                  PORTB.F3 = 1; PORTB.F3 = 0;
                  k++;                 }
                  Nzn--;                       }
              }

main (void)
{
begin:
           Init();
beg:
          speed = Eeprom_Read(0xFF); // .
          if (speed==0) speed=1;     //  .
basic:
          Clear_screen();
          INTCON.F6=1; //    .
          PIE1.F5=1;  //    USART.
          INTCON.F7=1;
          flags.F0=0; //0 -   UART - 
loop:
         if (flags.F0==0) goto jamp_int; //    UART.
//===============================================
         INTCON.F7=0;
loop_begin:
         if (Usart_Data_Ready()) {code_part1[0]=Usart_Read(); if (code_part1[0]==0x23) goto loop1;}
         goto miss;
loop1:
         k=0;
         while (k<63) {
loop0:       if (Usart_Data_Ready()) {code_part1[k] = Usart_Read(); goto dal1;}
             goto loop0;
dal1:
                if (code_part1[k]==0xD0) goto loop0; //    
                if (code_part1[k]==0xD1) goto loop0; //   .
                if (code_part1[k]==0x23) goto m23;
        k++;
                      }
         code_part1[62]=0x23;
         goto save;
m23:                //    .
                                // -     ?
                                text_comand[0]='S';
                                text_comand[1]='P';
                                text_comand[2]='E';
                                text_comand[3]='E';
                                text_comand[4]='D';
                                text_comand[5]='=';
                                for (s=0; s<5; s++) {if (code_part1[s]!=text_comand[s]) goto erase;}
                                EEprom_Write(0xFF, code_part1[6]-0x30); //   
                                s=0;
                                adress=0x00;
                                kol=0;
                                kol_pust=0;
                                flags.F0=0;
                                goto beg;
erase:
                  // -      ?
                  text_comand[0]='E';
                  text_comand[1]='R';
                  text_comand[2]='A';
                  text_comand[3]='S';
                  text_comand[4]='E';
                  text_comand[5]='=';
                  for (s=0; s<5; s++) {if (code_part1[s]!=text_comand[s]) goto save;}
                  if (code_part1[7]==0x23) {
                      code_part1[8]==0xFF;
                     l=code_part1[6]-0x30;
                     if (l==0) { //  ERASE=0
                        k_eeprom=0;
                        EEprom_Write(0x00, 0x2D); EEprom_Write(0x01, 0xFF);
                        goto cont;
                               }
                     goto er_1;
                                           }
                  if (code_part1[8]==0x23) {l=(code_part1[6]-0x30)*10+(code_part1[7]-0x30); goto er_1;}
                  goto cont;
er_1:             for (s=0; s<l; s++) {
                      k_eeprom--;
                      if (k_eeprom==0) {EEprom_Write(0x00, 0x2D); goto cont;}
                      EEprom_Write(k_eeprom, 0xFF);
                                      }
                  goto cont;


/*         k=0;
         while (k<63) {
loop00:       if (Usart_Data_Ready()) {code_part2[k] = Usart_Read(); goto dal2;}
              goto loop00;
dal2:           if (code_part2[k]==0xD0) goto loop00; //    
                if (code_part2[k]==0xD1) goto loop00; //   .
                if (code_part2[k]==0x23) goto save;  //    .
              k++;
                               }  */
save:    INTCON.F7=0;
         //s=k_eeprom;
         k=0;
         while (k<63) {
              if (code_part1[k]==0x23) code_part1[k]=0xFF;
              EEprom_Write(k_eeprom, code_part1[k]);
              if (k_eeprom<0xFE) k_eeprom++;
              if (code_part1[k]==0xFF) {k_eeprom--; goto cont;}
              k++;
                              }
/*         s=k_eeprom;
         k=0;
         while (k<63) {
              if (code_part2[k]==0x23) code_part2[k]=0xFF;
              EEprom_Write(s+k, code_part2[k]);
              k_eeprom++;
              if (code_part2[k]==0xFF) {k_eeprom--; goto cont;}
              k++;
                              } */
cont:
         //s=0;
         adress=0x00;
         kol=0;
         kol_pust=0;
         flags.F0=0;
         PIE1.F5=1;  //    USART.
         goto basic;
miss:      flags.F0=0;
           INTCON.F7=1;
           PIE1.F5=1;  //    USART.
//================================================
jamp_int:
            INTCON.F7=1; PIE1.F5=1;
            Output(speed); //    (  )

            if (code_sym==0x0D) {
               if (wait_tab<t_wait) {wait_tab++; goto loop;} else code_sym=0;
                                }
            wait_tab=0;

            Scroll(1); //    

            kol++;
            if (kol<bold) goto loop;         // bold   ?
            kol=0;

       //   EEPROM  
            if (adress==0xFF) goto end_stroki;
            code_sym = Eeprom_Read(adress);

            if (code_sym==0xFF) goto end_stroki;

            Symbol(); //      
            adress++;
            goto loop;
end_stroki:
               video_mem[0][zz] = 0b00000000;
               video_mem[1][zz] = 0b00000000;
               video_mem[2][zz] = 0b00000000;
               video_mem[3][zz] = 0b00000000;
               video_mem[4][zz] = 0b00000000;
               video_mem[5][zz] = 0b00000000;
               video_mem[6][zz] = 0b00000000;
               video_mem[7][zz] = 0b00000000;

               if (kol_pust==9) {adress=0x00; kol_pust=0;} else kol_pust++;
            goto loop;


}
